diff --git a/libfwupdplugin/fu-csv-entry.c b/libfwupdplugin/fu-csv-entry.c
index 6c09e9f00a0..fc0a7a3687c 100644
--- a/libfwupdplugin/fu-csv-entry.c
+++ b/libfwupdplugin/fu-csv-entry.c
@@ -91,6 +91,23 @@ fu_csv_entry_get_value_by_column_id(FuCsvEntry *self, const gchar *column_id)
 	return g_ptr_array_index(priv->values, idx);
 }
 
+gboolean
+fu_csv_entry_get_value_by_column_id_uint64(FuCsvEntry *self,
+					   const gchar *column_id,
+					   guint64 *value,
+					   GError **error)
+{
+	const gchar *str_value = fu_csv_entry_get_value_by_column_id(self, column_id);
+
+	if (str_value == NULL) {
+		g_set_error(error, FWUPD_ERROR, FWUPD_ERROR_NOT_FOUND, "CSV value not found");
+
+		return FALSE;
+	}
+
+	return fu_strtoull(str_value, value, 0, G_MAXUINT64, error);
+}
+
 static void
 fu_ifd_firmware_export(FuFirmware *firmware, FuFirmwareExportFlags flags, XbBuilderNode *bn)
 {
diff --git a/libfwupdplugin/fu-csv-entry.h b/libfwupdplugin/fu-csv-entry.h
index 82993254405..fab37f0f7c9 100644
--- a/libfwupdplugin/fu-csv-entry.h
+++ b/libfwupdplugin/fu-csv-entry.h
@@ -23,3 +23,8 @@ const gchar *
 fu_csv_entry_get_value_by_idx(FuCsvEntry *self, guint idx);
 const gchar *
 fu_csv_entry_get_value_by_column_id(FuCsvEntry *self, const gchar *column_id);
+gboolean
+fu_csv_entry_get_value_by_column_id_uint64(FuCsvEntry *self,
+					   const gchar *column_id,
+					   guint64 *value,
+					   GError **error);
diff --git a/libfwupdplugin/fu-efivar.h b/libfwupdplugin/fu-efivar.h
index 893a19a4f2a..48ba5319ef9 100644
--- a/libfwupdplugin/fu-efivar.h
+++ b/libfwupdplugin/fu-efivar.h
@@ -15,6 +15,7 @@
 #define FU_EFIVAR_GUID_SECURITY_DATABASE  "d719b2cb-3d3a-4596-a3bc-dad00e67656f"
 #define FU_EFIVAR_GUID_UX_CAPSULE	  "3b8c8162-188c-46a4-aec9-be43f1d65697"
 #define FU_EFIVAR_GUID_EFI_CAPSULE_REPORT "39b68c46-f7fb-441b-b6ec-16b0f69821f3"
+#define FU_EFIVAR_GUID_SHIM		  "605dab50-e046-4300-abb6-3dd810dd8b23"
 
 #define FU_EFIVAR_ATTR_NON_VOLATILE			     (1 << 0)
 #define FU_EFIVAR_ATTR_BOOTSERVICE_ACCESS		     (1 << 1)
diff --git a/libfwupdplugin/fu-sbatlevel-section.c b/libfwupdplugin/fu-sbatlevel-section.c
index 0f8b65df86c..d63b275f7dc 100644
--- a/libfwupdplugin/fu-sbatlevel-section.c
+++ b/libfwupdplugin/fu-sbatlevel-section.c
@@ -19,21 +19,21 @@ G_DEFINE_TYPE(FuSbatlevelSection, fu_sbatlevel_section, FU_TYPE_FIRMWARE);
 static gboolean
 fu_sbatlevel_section_add_entry(FuFirmware *firmware,
 			       GBytes *fw,
-			       const guint8 *buf,
-			       gsize bufsz,
-			       gsize entry_offset,
+			       gsize offset,
 			       const gchar *entry_name,
 			       guint64 entry_idx,
 			       FwupdInstallFlags flags,
 			       GError **error)
 {
+	gsize bufsz = 0;
+	const guint8 *buf = g_bytes_get_data(fw, &bufsz);
+	gsize size = 0;
 	g_autoptr(FuFirmware) entry_fw = NULL;
 	g_autoptr(GBytes) entry_blob = NULL;
-	gsize entry_size;
 
 	/* look for the null terminator */
-	for (entry_size = 0; ((entry_offset + entry_size) < bufsz); ++entry_size) {
-		if (buf[entry_offset + entry_size] == 0)
+	for (size = 0; ((offset + size) < bufsz); ++size) {
+		if (buf[offset + size] == 0)
 			break;
 	}
 
@@ -44,8 +44,8 @@ fu_sbatlevel_section_add_entry(FuFirmware *firmware,
 
 	fu_firmware_set_idx(entry_fw, entry_idx);
 	fu_firmware_set_id(entry_fw, entry_name);
-	fu_firmware_set_offset(entry_fw, entry_offset);
-	entry_blob = fu_bytes_new_offset(fw, entry_offset, entry_size, error);
+	fu_firmware_set_offset(entry_fw, offset);
+	entry_blob = fu_bytes_new_offset(fw, offset, size, error);
 	if (entry_blob == NULL)
 		return FALSE;
 	if (!fu_firmware_add_image_full(firmware, entry_fw, error))
@@ -63,26 +63,21 @@ fu_sbatlevel_section_parse(FuFirmware *firmware,
 			   FwupdInstallFlags flags,
 			   GError **error)
 {
-	const guint8 *buf = NULL;
-	gsize bufsz;
+	gsize bufsz = 0;
+	const guint8 *buf = g_bytes_get_data(fw, &bufsz);
 	gsize header_offset = offset + FU_STRUCT_SBAT_LEVEL_SECTION_HEADER_OFFSET_PREVIOUS;
 	guint32 previous_addr;
 	guint32 latest_addr;
 	g_autoptr(GByteArray) st = NULL;
 
-	buf = g_bytes_get_data(fw, &bufsz);
-
 	st = fu_struct_sbat_level_section_header_parse(buf, bufsz, offset, error);
 	if (st == NULL)
 		return FALSE;
 
 	previous_addr = fu_struct_sbat_level_section_header_get_previous(st);
-	latest_addr = fu_struct_sbat_level_section_header_get_latest(st);
 
 	if (!fu_sbatlevel_section_add_entry(firmware,
 					    fw,
-					    buf,
-					    bufsz,
 					    header_offset + previous_addr,
 					    "previous",
 					    0,
@@ -90,10 +85,10 @@ fu_sbatlevel_section_parse(FuFirmware *firmware,
 					    error))
 		return FALSE;
 
+	latest_addr = fu_struct_sbat_level_section_header_get_latest(st);
+
 	if (!fu_sbatlevel_section_add_entry(firmware,
 					    fw,
-					    buf,
-					    bufsz,
 					    header_offset + latest_addr,
 					    "latest",
 					    1,
diff --git a/plugins/uefi-capsule/fu-uefi-bootmgr.c b/plugins/uefi-capsule/fu-uefi-bootmgr.c
index a223cc2802e..d8ee76838d6 100644
--- a/plugins/uefi-capsule/fu-uefi-bootmgr.c
+++ b/plugins/uefi-capsule/fu-uefi-bootmgr.c
@@ -249,6 +249,137 @@ fu_uefi_setup_bootnext_with_loadopt(FuEfiLoadOption *loadopt, GError **error)
 	return TRUE;
 }
 
+static gboolean
+fu_uefi_bootmgr_shim_is_safe(const gchar *source_shim, GError **error)
+{
+	gsize idx = 0;
+	g_autoptr(GBytes) current_sbatlevel_bytes = NULL;
+	g_autoptr(FuFirmware) shim = NULL;
+	g_autoptr(FuFirmware) sbatlevel_section = NULL;
+	g_autoptr(FuFirmware) previous_sbatlevel = NULL;
+	g_autoptr(FuFirmware) current_sbatlevel = NULL;
+	g_autoptr(GError) error_local = NULL;
+	g_autoptr(GBytes) blob = NULL;
+	g_autoptr(GBytes) sbatlevel_bytes = NULL;
+	g_autoptr(GPtrArray) shim_entries = NULL;
+
+	shim = fu_pefile_firmware_new();
+	blob = fu_bytes_get_contents(source_shim, error);
+	if (blob == NULL)
+		return FALSE;
+	if (!fu_firmware_parse(shim, blob, FWUPD_INSTALL_FLAG_NONE, error))
+		return FALSE;
+
+	sbatlevel_section = fu_firmware_get_image_by_id(shim, ".sbatlevel", &error_local);
+	if (sbatlevel_section == NULL) {
+		g_debug("no sbatlevel section was found");
+		/* if there is no .sbatlevel section, then it will not update, it should be safe */
+		if (g_error_matches(error_local, FWUPD_ERROR, FWUPD_ERROR_NOT_FOUND))
+			return TRUE;
+		g_propagate_error(error, g_steal_pointer(&error_local));
+	}
+
+	previous_sbatlevel = fu_firmware_get_image_by_id(sbatlevel_section, "previous", error);
+	if (previous_sbatlevel == NULL)
+		return FALSE;
+
+	shim_entries = fu_firmware_get_images(previous_sbatlevel);
+
+	current_sbatlevel_bytes =
+	    fu_efivar_get_data_bytes(FU_EFIVAR_GUID_SHIM, "SbatLevelRT", NULL, error);
+	/* not safe if variable is not set but new shim would set it */
+	if (current_sbatlevel_bytes == NULL)
+		return FALSE;
+
+	current_sbatlevel = fu_csv_firmware_new();
+	fu_csv_firmware_add_column_id(FU_CSV_FIRMWARE(current_sbatlevel), "$id");
+	fu_csv_firmware_add_column_id(FU_CSV_FIRMWARE(current_sbatlevel), "component_generation");
+	fu_csv_firmware_add_column_id(FU_CSV_FIRMWARE(current_sbatlevel), "date_stamp");
+
+	if (!fu_firmware_parse(current_sbatlevel,
+			       current_sbatlevel_bytes,
+			       FWUPD_INSTALL_FLAG_NONE,
+			       error))
+		return FALSE;
+
+	/*
+	 * For every new shim entry, we need a matching entry in the
+	 * current sbatlevel. That is the entry of the shim is not
+	 * newer than current sbatlevel.
+	 *
+	 * The opposite way might work (for example shim's latest
+	 * sbatlevel matches) or not (shim is too old), but it will
+	 * not brick the current OS.
+	 */
+	for (idx = 0; idx < shim_entries->len; idx++) {
+		const gchar *entry_id = NULL;
+		guint64 shim_generation = 0;
+		guint64 current_generation = 0;
+		FuCsvEntry *current_entry = NULL;
+		FuCsvEntry *shim_entry = g_ptr_array_index(shim_entries, idx);
+
+		entry_id = fu_firmware_get_id(FU_FIRMWARE(shim_entry));
+
+		current_entry =
+		    FU_CSV_ENTRY(fu_firmware_get_image_by_id(FU_FIRMWARE(current_sbatlevel),
+							     entry_id,
+							     &error_local));
+		if (current_entry == NULL) {
+			if (g_error_matches(error_local, FWUPD_ERROR, FWUPD_ERROR_NOT_FOUND)) {
+				g_set_error(
+				    error,
+				    FWUPD_ERROR,
+				    FWUPD_ERROR_INVALID_FILE,
+				    "shim sbatlevel for %s has a bricking update for entry %s "
+				    "(missing entry in current UEFI variable)",
+				    source_shim,
+				    entry_id);
+			} else {
+				g_prefix_error(&error_local,
+					       "while looking for entry in current sbatlevel: ");
+				g_propagate_error(error, g_steal_pointer(&error_local));
+			}
+
+			return FALSE;
+		}
+
+		if (!fu_csv_entry_get_value_by_column_id_uint64(shim_entry,
+								"component_generation",
+								&shim_generation,
+								error)) {
+			g_prefix_error(error,
+				       "sbatlevel entry %s for shim %s: ",
+				       entry_id,
+				       source_shim);
+
+			return FALSE;
+		}
+
+		if (!fu_csv_entry_get_value_by_column_id_uint64(current_entry,
+								"component_generation",
+								&current_generation,
+								error)) {
+			g_prefix_error(error, "entry %s from current sbatlevel: ", entry_id);
+
+			return FALSE;
+		}
+
+		if (current_generation < shim_generation) {
+			g_set_error(error,
+				    FWUPD_ERROR,
+				    FWUPD_ERROR_INVALID_FILE,
+				    "sbatlevel for shim %s has a bricking update for entry "
+				    "%s (newer generation)",
+				    source_shim,
+				    entry_id);
+
+			return FALSE;
+		}
+	}
+
+	return TRUE;
+}
+
 gboolean
 fu_uefi_bootmgr_bootnext(FuVolume *esp,
 			 const gchar *description,
@@ -286,6 +417,8 @@ fu_uefi_bootmgr_bootnext(FuVolume *esp,
 		source_shim = fu_uefi_get_built_app_path("shim", NULL);
 		if (source_shim != NULL) {
 			if (!fu_uefi_esp_target_verify(source_shim, esp, shim_app)) {
+				if (!fu_uefi_bootmgr_shim_is_safe(source_shim, error))
+					return FALSE;
 				if (!fu_uefi_esp_target_copy(source_shim, esp, shim_app, error))
 					return FALSE;
 			}
